# Numerik Vorkurs
# Blatt 4 Aufgabe 1
# Christian Power 11.10.2016

"""
Funktion die man plotten soll
exp(x) sin(y^2)

- **Precondition**: (x,y) ∈[-3,3]^2
- **Postcondition**: Erg. in R
- **Bemerkung**: Wurde vektorisiert.
"""
b4a1fun(x,y) = exp(x) .* sin(y.^2)
# Die obigen Notation ist eine kürzere Schreibweise

"""
matlabMesh(x,y) imitiert meshgrid() von Matlab.  Anschaulich ist das das 
Kartesische Produkt von den Intervallen x und y.

**Precondition**: x, y ∈ R^n, welche Intervalle darstellen sollen.
**Postcondition**: xGrid, yGrid ∈ R^(n x n), welche das Kart. Prod. darstellen soll.
"""
function matlabMesh(x,y)
    assert(ndims(x)==1 && ndims(y)==1)
    assert(length(x) == length(y))
    n = length(x)
    xGrid = zeros(n,n)
    yGrid = copy(xGrid)
    for i=1:n
        for j=1:n
            xGrid[i,j] = x[j]
            yGrid[i,j] = y[i]
        end
    end
    return (xGrid, yGrid)
end


"""
Erzeugt den gewünschten Plot

- **Precondition**: using PyPlot
"""
function b4a1_plot()
    x_interval = -3:.1:3
    y_interval = x_interval
    (x_gitter, y_gitter) = matlabMesh(x_interval, y_interval)
    z_werte = b4a1fun(x_gitter, y_gitter)
    plot_surface(x_gitter, y_gitter, z_werte,
                 cmap=ColorMap("jet"),
                 rstride=1,cstride=1)
end

b4a1_plot()

# ----------------------------------------------------------------------
# Tests

"""
Testet alle Bauteile von Blatt 4 A 1
"""
function b4a1_test()
    local toleranz = 1e-8
    assert(norm(b4a1fun([rand();rand()],[sqrt(π),sqrt(2*π)])) < toleranz)
end

b4a1_test() # Lasse Test laufen

