# Numerik Vorkurs
# Blatt 4 Aufgabe 4
# Christian Power 11.10.2016

"""
wurzel(a, tol) implementiert das Heron Wurzelziehen.
Von `a` wird die Wurzel gezogen und `tol` gibt die Genauigkeit an.
Gibt eine Nährung der Wurzel von `a` und die Anzahl der Iterationsschritte zurück.

- **Precondition**: Eingabge ist positive
- **Postcondition**: abs(echte_Lösung - Ergebnis) < tol 
"""
function wurzel(a, tol)
    assert(a>0)
    assert(tol>0)
    x_alt = 2*a + 2*tol # Das ist künstlich. x_alt wird gleich überschrieben
    x_neu = 2*a
    it_no = 0   # Anzahl der Iterationen
    while abs(x_neu - x_alt) > tol
        x_alt = x_neu
        x_neu = .5*(x_alt + a/x_alt)
        it_no += 1
    end
    return (x_neu, it_no)
end


# ----------------------------------------------------------------------
# Tests

"""
b4a4_test() testet 
"""
function b4a4_test()
    toleranz = .8
    for n = 1:9
        (wurzel_von_n2, ~) = wurzel(n*n,toleranz)
        assert(abs(wurzel_von_n2-n)<toleranz)
    end
    (wurzel_von_2, ~) = wurzel(2,toleranz)
    assert(abs(wurzel_von_2-1.4)<.3)
end

b4a4_test()  # Lasse Tests laufen
