workspace()
"""
Rekursive Fakultätsfunktion
"""
function fak_rek(n::BigInt)
  if n <= 1
    return 1
  else
    return fak_rek(n-1) * n
  end
end
function fak_rek(n::Int)
  fak_rek(BigInt(n))
end

"""
for-loop Fakultät
"""
function fakul(n::BigInt)
    rv = 1
    for i=2:n
        rv *= i
    end
    return rv
end
function fakul(n::Int)
    fakul(BigInt(n))
end

"""
Teste fak_rek() und fakul()
"""
function fak_test()
    assert(fak_rek(3)==6)
    assert(fak_rek(1)==1)
    assert(fak_rek(0)==1)
    assert(fak_rek(-1)==1)
    assert(fakul(-1)==1)
    
    local n = 10
    for i = 0:n
        assert(fakul(i)==fak_rek(i))
    end
end

fak_test()
n = BigInt(100)
tic()
fak_rek(n)
toc()
tic()
fakul(n)
toc()
