using PyPlot
x = [a for a = -1:.1:1]
y = x
"""
matlabMesh(x,y) immitiert die entsprechende Matlab Funktion.
**Precondition**: x, y ∈ R^n
**Postcondition**: xGrid, yGrid ∈ R^(n x n) 
"""
function matlabMesh(x,y)
    assert(ndims(x)==1 && ndims(y)==1)
    assert(length(x) == length(y))
    n = length(x)
    xGrid = zeros(n,n)
    yGrid = copy(xGrid)
    for i=1:n
        for j=1:n
            xGrid[i,j] = x[j]
            yGrid[i,j] = y[i]
        end
    end
    return (xGrid, yGrid)
end
(xGrid, yGrid) = matlabMesh(x,y)
zGrid = xGrid.^2 - yGrid.^2
plot_surface(xGrid,yGrid,zGrid,
             cmap=ColorMap("jet"),
             rstride=1,cstride=1)
savefig("../fig/graph3d.pdf")
